package es.uv.garcosda.controllers;

import java.util.Random;

import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.messaging.handler.annotation.Header;
import org.springframework.stereotype.Controller;
import org.springframework.web.client.RestTemplate;

import es.uv.garcosda.domain.User;
import es.uv.garcosda.objects.MailDTO;

@Controller
public class WorkerController {

	RestTemplate restTemplate;
	
	public WorkerController() {
		this.restTemplate = new RestTemplate();
	}
	
	public static String generatePasswd(int len) {
	    String AB = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	    Random rnd = new Random();

	    StringBuilder sb = new StringBuilder(len);
	    for (int i = 0; i < len; i++) {
	        sb.append(AB.charAt(rnd.nextInt(AB.length())));
	    }
	    return sb.toString();
	}
	
	@RabbitListener(queues = {"${rabbitmq.queue.name.user}"})
	public void compute(User user) {
		try {
		    Thread.sleep(10 * 1000);
		} 
		catch (InterruptedException ie) {
		    Thread.currentThread().interrupt();
		}
		
		String passwd = generatePasswd(6);
		HttpEntity<MailDTO> request = new HttpEntity<>(new MailDTO("system@mailer.com", user.getEmail(), "Welcome to Mailer APP", "Welcome to mailer app. You can access to your account by using this password: "+passwd));
		restTemplate.postForObject("http://localhost:8080/api/v1/mailbox", request, String.class);
	
	}
	
	@RabbitListener(queues = {"${rabbitmq.queue.name.recover}"})
	public void computePasswd(User user) {		
		try {
		    Thread.sleep(10 * 1000);
		} 
		catch (InterruptedException ie) {
		    Thread.currentThread().interrupt();
		}
		
		String passwd = generatePasswd(6);
		HttpEntity<MailDTO> request = new HttpEntity<>(new MailDTO("system@mailer.com", user.getEmail(), "Your new password", "Your new password is: "+passwd));
		restTemplate.postForObject("http://localhost:8080/api/v1/mailbox", request, String.class);
	
	}
	
	@RabbitListener(queues = {"${rabbitmq.queue.name.system}"})
	public void computeSystem(User user, Message message) {
		HttpEntity<MailDTO> request;
		if(message.getMessageProperties().getReceivedRoutingKey().toLowerCase().equals("k.new_user")) {
			request = new HttpEntity<>(new MailDTO("system@mailer.com", "system@mailer.com", "New account created", "Created new account for user "+user.getEmail()));
		}
		else {
			request = new HttpEntity<>(new MailDTO("system@mailer.com", "system@mailer.com", "Password recover", "Password recover issued by "+user.getEmail()));
		}
		
		restTemplate.postForObject("http://localhost:8080/api/v1/mailbox", request, String.class);
	}
}
